<?php
//
// +---------------------------------------------------------------------------+
// | Top Contributors Block (topguys v1.01) for Geeklog                         |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// +---------------------------------------------------------------------------+
// | This file contains a function which calculates and then displays the      |
// | top story and comment contributors on your site.                          |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2003 by DoYourDD (geek@doyourdd.com)                        |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

function phpblock_topGuys()
{

    global $_TABLES, $_CONF;

    /***************************************************************************/
    /*  Set these configuration variables to meet your website's requirements  */
    /***************************************************************************/

    // number of top story contributors to display 
    $top_story_submitters = 5;

    // number of top comment contributors to display
    $top_comment_submitters = 5;

    // list of aliases you do not want shown at all (case insensitive)
    $exclude_list = 'Mark, Gina, Tom, Nancy';

    // title to display above the stories and comments contributor lists 
    $story_title = 'STORIES';
    $comment_title = 'COMMENTS';

    /****************************************************************************/
    /*  Please do not modify the code below unless you know what you are doing  */
    /****************************************************************************/

    // number of database queries this function makes
    $total_queries = 2;

    // initialize display variable
    $display = '';

    // sql calls to pull the data we need
    $sql[1] = "SELECT {$_TABLES['stories']}.uid, {$_TABLES['users']}.username, COUNT(*) AS total FROM {$_TABLES['stories']}, {$_TABLES['users']} WHERE ({$_TABLES['stories']}.draft_flag = 0 AND {$_TABLES['stories']}.uid = {$_TABLES['users']}.uid) GROUP BY {$_TABLES['stories']}.uid ORDER BY total DESC";

    $sql[2] = "SELECT {$_TABLES['comments']}.uid, {$_TABLES['users']}.username, COUNT(*) AS total FROM {$_TABLES['comments']}, {$_TABLES['users']} WHERE {$_TABLES['comments']}.uid = {$_TABLES['users']}.uid GROUP BY {$_TABLES['comments']}.uid ORDER BY total DESC";

    // loop through the code twice
    for ($nbr = 1; $nbr <= $total_queries; $nbr++) {

        // execute the sql call and find the number of rows
        $result = DB_query($sql[$nbr],0);
        $numrows = DB_numRows($result);

        // continue on only if there is data to process
        if ($numrows >= 1) {

            // initialize variables for output
            $namecount = 0;
            $all_done = 0;

            // if nbr = 1 process story submitters, if nbr = 2 process comment submitters
            if ($nbr == 1) {
                $display .= '<b>' . $story_title . '</b><br />';
                $all_done = $top_story_submitters;
            }
            elseif ($nbr == 2) {
                $display .= '<br /><b>' . $comment_title . '</b><br />';
                $all_done = $top_comment_submitters;
            }

            // retrieve the info from each database row and assign it to a variable
            for ($count = 0; $count < $numrows; $count++) {
                $row = DB_fetchArray($result);
                $uid = $row['uid'];
                $username = $row['username'];
                $total = $row['total'];

                // bypass those in the exclude list
                if (!stristr($exclude_list,$username)) {
                    $display .= '<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $uid . '">' . $username . '</a> ('.$total.') <br />';
                    $namecount++;

                    // if not done so already, jump out of this loop when it reaches 
                    // the desired number to display
                    if ($namecount >= $all_done)
                        break;
                }  // end if
            }  // end for
        }  // end if
    }  // end for

    // send the output to Geeklog
    return $display;

} // end function phpblock_topGuys

?>